<template>
    <form method="post" action="#" class="mt-5 mb-5" @submit.prevent="sendForm">
        <div class="form-group">
            <div class="row">
                <div class="col-10">
                    <input @keyup="emptyErrors" type="text" v-model="search" placeholder="Start your journey here..." name="search" class="form-control" />
                    <span class="text-danger" v-if="errors.search.length">{{ errors.search }}</span>
                </div>
                <div class="col-2">
                    <button type="submit" class="btn btn-outline-success btn-block">Search</button>
                </div>
            </div>
        </div>
    </form>
</template>

<script>
    import axios from 'axios'
    import EventBus from "../app"

    export default {
        data(){
            return {
                baseURL:"https://itunes.apple.com/search?term=",
                search:"",
                errors:{
                    search:""
                }
            }
        },
        methods:{
            emptyErrors(){
                this.errors.search = ""
            },
            sendForm(){
                if(this.search.length) {
                    axios.get(this.baseURL + encodeURI(this.search)).then( res => {
                        if(res.data && res.data.results && res.data.results.length) {
                            EventBus.$emit('search-data', res.data)
                        }else{
                            this.errors.search = "Oooops.....Something went wrong"
                        }
                    }).catch( err => {
                        console.log(err)
                        this.errors.search = "Oooops.....Something went wrong"
                    })
                }else{
                    this.errors.search = "Please, enter artist name"
                }
            }
        }
    }
</script>

<style scoped>

</style>